;;;; intarweb-conditions.memo.scm  -*- Scheme -*-
;;;; Kon Lovett, Jan '23

(module (intarweb-conditions memo)

(;export
  get)

(import scheme
  (chicken base)
  condition-utils)

;;; Intarweb Egg Conditions

(define (get sym)
  (case sym

    ;
    ((http-condition?) (make-condition-predicate exn http))

    ;
    ((urlencoded-request-data-limit-exceeded?) (make-condition-predicate exn http urlencoded-request-data-limit-exceeded))
    ((urlencoded-request-data-limit-exceeded-contents) (make-condition-property-accessor urlencoded-request-data-limit-exceeded contents))
    ((urlencoded-request-data-limit-exceeded-limit) (make-condition-property-accessor urlencoded-request-data-limit-exceeded limit))

    ;
    ((line-limit-exceeded?) (make-condition-predicate exn http line-limit-exceeded))
    ((line-limit-exceeded-contents) (make-condition-property-accessor line-limit-exceeded contents))
    ((line-limit-exceeded-limit) (make-condition-property-accessor line-limit-exceeded limit))

    ;
    ((header-error?) (make-condition-predicate exn http header-error))
    ((header-error-contents) (make-condition-property-accessor header-error contents))

    ;
    ((header-limit-exceeded?) (make-condition-predicate exn http header-limit-exceeded))
    ((header-limit-exceeded-contents) (make-condition-property-accessor header-limit-exceeded contents))
    ((header-limit-exceeded-limit) (make-condition-property-accessor header-limit-exceeded limit))

    ;
    ((unknown-protocol-line?) (make-condition-predicate exn http unknown-protocol-line))
    ((unknown-protocol-line-line) (make-condition-property-accessor unknown-protocol-line line))

    ;
    ((unknown-protocol?) (make-condition-predicate exn http unknown-protocol))
    ((unknown-protocol-major) (make-condition-property-accessor unknown-protocol major))
    ((unknown-protocol-minor) (make-condition-property-accessor unknown-protocol minor))

    ;
    ((unknown-code?) (make-condition-predicate exn http unknown-code))
    ((unknown-code-code) (make-condition-property-accessor unknown-code code))

    ;
    ((unknown-status?) (make-condition-predicate exn http unknown-status))
    ((unknown-status-status) (make-condition-property-accessor unknown-status status))

    ;
    ((rfc1123-subparser?) (make-condition-predicate exn http rfc1123-subparser))
    ((rfc1123-subparser-value?) (make-condition-property-accessor rfc1123-subparser value))

    ;
    ((rfc850-subparser?) (make-condition-predicate exn http rfc850-subparser))
    ((rfc850-subparser-value?) (make-condition-property-accessor rfc850-subparser value))

    ;
    ((asctime-subparser?) (make-condition-predicate exn http asctime-subparser))
    ((asctime-subparser-value?) (make-condition-property-accessor asctime-subparser value))

    ;
    ((http-date-subparser?) (make-condition-predicate exn http http-date-subparser))
    ((http-date-subparser-value?) (make-condition-property-accessor http-date-subparser value))

    ;
    ((unencoded-header?) (make-condition-predicate exn http unencoded-header))
    ((unencoded-header-value?) (make-condition-property-accessor unencoded-header value))

    ;
    ((username-with-colon?) (make-condition-predicate exn http username-with-colon))
    ((username-with-colon-value?) (make-condition-property-accessor username-with-colon value))

    ;
    (else (error 'get "undefined intarweb-conditions item" sym))
  )
)

) ;(intarweb-conditions memo)
